module emlfit

  use oal
  use cal
  use param
  use dal
  use sla
  use edetect_io_ml
  use edetect_gen
  use emldata
  use psf
  use fftpsf

  implicit none

  private

  public mulsou, model, mlfit, funct, like, ordr, pordr


contains

  !---------------------------------------------------------------------
      subroutine mulsou (nsrc,sxms,syms,ssigma,sscts,rate,ra,dec,lii,bii, &
                         chipix,chipiy,ccdinr,offax, &
                         exms,eyms,esigma,escts,erate,eradec, &
                         exi_ml,ext_ml,ecut2,srcexpos,vignetting,srcontime,insrc,first)
  !---------------------------------------------------------------------

      real, intent(in) :: ecut2
      integer, intent(inout) :: nsrc
      real, dimension(max_fit), intent(inout) :: sxms, syms, ssigma,  &
                                                 exms, eyms, esigma, ext_ml

      real(kind=double), dimension(max_fit), intent(out) :: ra, dec, lii, bii
      real(kind=double), dimension(max_fit) :: xms, yms ,sigma
      real(kind=double), dimension(max_ima,max_fit) :: scts
      real(kind=single), dimension(max_fit) ::  eradec
      real, dimension(max_ima,max_fit), intent(inout) :: sscts, escts, &
                                                         rate, erate,exi_ml
      real, dimension(max_ima,max_fit) :: srcexpos
      real(kind=single),  dimension(max_ima,max_fit) :: vignetting,srcontime
      integer, dimension(max_ins,max_fit), intent(out) :: chipix,chipiy,ccdinr 
      real(kind=double), dimension(max_ins,max_fit)  :: offax,azim
      real :: effarea_cen,effarea_src
      real :: distsq,extdiff,mindist=1.5,minextdiff=1.0
      logical :: multflag, maskbad
      real ::       yfit1(max_events),yfit2(max_ima), &
                    yfit3,dml(max_fit), &
                    fe(max_par),df, &
                    felhi,fello, flamda, sc,rcal, x1,y1,exp,expn,expj,ene

      real(kind=double) :: like00,like0,like1,likold,like1_arr(max_ima),lik_arr(max_ima), &
                           likmerk,lik_amerk(max_ima),like00arr(max_ima),lik_arr_save(max_ima,0:nsrc), &
                           likesave(0:nsrc),delfit(max_par), &
                           a(max_par),deltaa(max_par),deltae(max_par),sigmaa(max_par),afit(max_par), &
                           amerk(max_par),sigfit(max_par),atemp(max_par)
   
      ! diagnostic variable:
      real :: likediff
      !
      real(kind=double) :: asave(max_par,0:nsrc)
      real(kind=double) :: astart(max_par)
      real :: like2dof(0:nsrc),likecorr
      real :: bestlike,dmlthresh
      integer :: bestfit=0
      logical :: oldfit
      integer :: ordsave(max_par)
      integer :: ntermf0,ntfix0,ndof
      integer :: nn
      !
      real(kind=double) :: xr,yr,dra,ddec,r0r,d0r,rr,dr,sin_pa,cos_pa, &
                    lr,br,fac
      integer ::    ierr,ioff0,ioff1,ioff,noff,i,ifel,ix0,iy0, &
                    npsou,ipoint,iordr(max_par),iordr0(max_par),iorde(max_par), &
                    j,insrc(max_fit),ical,nzero,iimage, &
                    ix,iy,l,m,n,nlauf,ntermf,ntfix,nffix,np,nima,nband,masksum,cutsum
      logical       done,first
      character(len=6) :: minmeth 
        

      integer, parameter :: irad = 120, maxfun=1000, iprint=0
      real, parameter :: delt = 1e-6
      real(kind=double), parameter ::  rhobeg=0.1, rhoend=1.D-6
!---JR
      real :: testsum
  
     integer:: istate1    
       minmeth='mrqmin'
!      minmeth='powell' 

     if (testoutput) write(*,*) "start MULSOU:",nsrc
!     write(*,*) "input scts:", scts(1:6,1)
!     if (nsrc == 2) write(*,*) "scts:", scts(1:15,2)
     if (testoutput) write(*,*) "input x1,y1:", xms(1),yms(1)
     if (testoutput .and. nsrc == 2) write(*,*) "x2,y2:", xms(2),yms(2)

      ! read new CAL PSF for new cluster:
      newcal = .true.

      oldfit = .false.
      
!      convert fit parameters to double precision (23/06/06 GL)      
      do i=1,max_fit
        xms(i)=dble(sxms(i))
        yms(i)=dble(syms(i))
        sigma(i)=dble(ssigma(i))
        do j=1,max_ima
          scts(j,i)=dble(sscts(j,i))
        enddo
      enddo

!      call system_clock(clock0,clock2,clock3)


      count_psf=0

      ierr=0
      ntfix = 0
      nlauf=0

!      ical=45/pixim
!      ical=60/pixim
!---------------------------------------------------------------------------------
!--- (JR) ------------------------------------------------------------------------
    psfmod = stringParameter("psfmodel")
    if (psfmod == "ellbeta") then
        modpsf = .true.
    else
        modpsf = .false.
    endif
!---------------------------------------------------------------------------------
!---------------------------------------------------------------------------------
!-------------------------------------
!-- JR -------------------------------
      if (modpsf) then
        ical=280./pixim
        else
        ical=60./pixim
      endif
!-------------------------------------
!-------------------------------------
      rcal=ical
      nspar=3
      npsou=nim+nspar
      np=npsou*nsrc
      do i=1,nsrc
        ioff=npsou*(i-1)
        sc=0.0
        do j=1,nim
          expj=exp_image(ixb(nint(xms(i)),j),iyb(nint(yms(i)),j),j)  !(JR)
!          expj=exp_image(max(1,min(npix(1),nint(xms(i)))), &
!                           max(1,min(npix(2),nint(yms(i)))),j)
          expj=max(expj,1.0)
          if (randomflag .and. .not. scts(j,i) > 0.) then
             scts(j,i)=0.0
          endif
          if (scts(j,i)<=0. .and. .not. randomflag) then 
!            scts(j,i)=100./expj
!           try 10 counts (04/05/06)
             scts(j,i)=10./expj
          else if (.not. scts(j,i) > 0.) then
!           catch NULL values from input list           
            scts(j,i)=0.0
          endif
            a(ioff+3+j)=scts(j,i)
            deltaa(ioff+3+j)=max(sqrt(scts(j,i)*expj)/expj,1.D-5)
            deltae(ioff+3+j)=deltaa(ioff+3+j)
            sc=sc+a(ioff+3+j)*expj
        end do
!       assume 10 counts, if all input values were 0 or NULL:  
        sc=max(sc,10.)
        a(ioff+1)=xms(i)
        deltaa(ioff+1)=2.0/sqrt(sc)
        deltae(ioff+1)=deltaa(ioff+1)
        a(ioff+2)=yms(i)
        deltaa(ioff+2)=2.0/sqrt(sc)
        deltae(ioff+2)=deltaa(ioff+2)
!   use larger delta for nmulsou>1:
        if (nsmul>1) then
          deltaa(ioff+1)=1.0
          deltaa(ioff+2)=1.0
        endif
!   different options to initialize extent parameter
        if (input_ext) then
          ! use extent from input list
          a(ioff+3)=sigma(i) 
        else
          if (extfla) then 
            a(ioff+3)=5.0
          else
            a(ioff+3)=0.
          endif
        endif

        deltaa(ioff+3)=1.0 
!        (use counts dependent stepsizes for felsu, GL 29/06/06):
        deltae(ioff+3)=10.0/sqrt(sc)
      end do
      !end loop over nsrc



    done = .false.
    do while (.not. done .and. fitflag)


!    write(*,*) "nspar,npsou,np:",nspar,npsou,np

!-----------------------------------------------------------

      iordr(1)=0
      call ordr(np,np,iordr) 
      iordr0=iordr                                          

      nffix=0
      nspar=3
      ntermf=np
! optionally fix sigmas in fit
      if (.not. extfla) then
        do i=1,nsrc
          ioff=npsou*(i-1)
          call ordr(np,ioff+3,iordr)
        end do
        ntermf=ntermf-nsrc
        ntfix=nsrc
        if (.not. xidfix) nspar=nspar-1
      end if

! optionally fix positions in fit
      if (.not. posfla) then
        do n=1,nsrc
          ioff=npsou*(n-1)
          call ordr(ntermf,ioff+1,iordr)
          call ordr(ntermf,ioff+2,iordr)
        enddo
        ntermf=ntermf-2*nsrc
        ntfix=ntfix+2*nsrc
        if (.not. xidfix) nspar=nspar-2
      endif

!  set number of input images nband (06/11/05) 
      nband=0
      do j=1,num_instr
        nband=nband+num_image(j) 
      enddo

! fix count rate at zero if mask in entire source region is zero:
 

!    set flux to zero, if maskzero=1    
      do n=1,nsrc
        ioff=npsou*(n-1)
        do j=1,nim         
          if (maskzero(n,j) == 1) then
            a(ioff+3+j)=0.0
            deltaa(ioff+3+j)=0.0
            call ordr(ntermf,ioff+3+j,iordr)
            ntermf=ntermf-1
            ntfix=ntfix+1
          endif
        end do
      end do
      iordr0=iordr
      ntermf0=ntermf
      ntfix0=ntfix

!-------------------------------------------

!  write(*,*) "start, ntermf,ntfix:",ntermf,ntfix
!  write(*,*) "start, iordr:",iordr(1:6)
!  write(*,*) "start, maskzero:", maskzero(1,1:3)

!*********************************************************************************************

     if (xidfix) then
       ! simply fit fluxes for all sources: 
       call pordr(np,a,afit,iordr,1)
       call pordr(np,deltaa,delfit,iordr,1)
       call pordr(np,sigmaa,sigfit,iordr,1)
       do nlauf=1,50
         flamda=1e-2    
         call mlfit(ntermf,afit,delfit,sigfit,iordr,xms,yms,ecut2, &
                    flamda,yfit1,like0,lik_arr, nsrc, ntfix, ierr)
         if(abs(likold-like0).le.delt) then
           exit
         endif
         likold=like0
       end do
       call pordr(np,a,afit,iordr,-1)                                   
       call pordr(np,deltaa,delfit,iordr,-1)                            
       call pordr(np,sigmaa,sigfit,iordr,-1)
       likesave(0)=like0
       lik_arr_save(:,0)=lik_arr
       asave(:,0)=a
       bestfit=0 
!       write(*,*) "xidfix params:", a(1:6) 
     endif


!      call system_clock(clock1,clock2,clock3) 
!      write(*,*) "clock:",clock1-clock0 

     if (.not. xidfix) then
       ! calculate likelihood value for null hypothesis (all fluxes zero)
       atemp=a
       iordr(1)=0
       call ordr(np,np,iordr)
       do i=1,nsrc
         ioff=npsou*(i-1)
         atemp(ioff+3)=0.0
         do j=1,nim
           atemp(ioff+3+j)=0.0
         enddo
       end do
       call funct(atemp,iordr,yfit1,yfit2,yfit3,nsrc,np,xms,yms,ecut2)
       call like(like00,like00arr,yfit1,yfit2)
       if (testoutput) write(*,*) "like00:",like00
       iordr=iordr0
       !!!

       bestfit=0
       ! first point source fit: fix all sigmas at zero:
!       write(*,*) "Nsrc:",nsrc
       do i=1,nsrc
          ioff=npsou*(i-1)
          a(ioff+3)=0.0
          call ordr(np,ioff+3,iordr)
       end do
       if (extfla) then
         ntermf=ntermf-nsrc
         ntfix=ntfix+nsrc 
         nspar=nspar-1
       endif

!       write(*,*) "2 pnt iordr:", iordr(1:36)
!       write(*,*) "2 pnt ntermf,ntfix,nspar:",ntermf,ntfix,nspar
!      write(*,*) "iordr f"
       call pordr(np,a,afit,iordr,1)
       call pordr(np,deltaa,delfit,iordr,1)
       call pordr(np,sigmaa,sigfit,iordr,1)
         do nlauf=1,50
           flamda=1e-2    
           call mlfit(ntermf,afit,delfit,sigfit,iordr,xms,yms,ecut2, &
                                   flamda,yfit1,like0,lik_arr, nsrc, ntfix, ierr)
!           write(*,*) "likediff:",likold-like0
           if(abs(likold-like0).le.delt) then
             exit
           endif
           likold=like0
         end do
       call pordr(np,a,afit,iordr,-1)                                   
       call pordr(np,deltaa,delfit,iordr,-1)                            
       call pordr(np,sigmaa,sigfit,iordr,-1)
       likesave(0)=like0
       lik_arr_save(:,0)=lik_arr
       nzero=0
       do n=1,nsrc
         do iimage=1,max_ima
           nzero=nzero+maskzero(n,iimage)
         end do
       enddo
       if (testoutput) write(*,*) "(like2dof) nsrc,nspar,nband,nzero:", nsrc,nspar,nband,nzero
       likediff=like00-like0
       if (testoutput) write(*,*) likediff
       like2dof(0)=gammq(real(nsrc*(nspar+nband)-nzero)/2.,likediff)
       asave(:,0)=a
       if (testoutput) write(*,*) "2 pnt,nlauf, like0:",nlauf,like0
       if (testoutput) write(*,*) "2 pntsrc:a(1:9)", a(1:9)
!       write(*,*) "lik_arr(1:6)",lik_arr(1:6)
       if (testoutput) write(*,*) "2 pntsrc:a(19:36)", a(19:36)

!      call system_clock(clock1,clock2,clock3) 
!      write(*,*) "2 pnt clock:",clock1-clock0     
     
     endif
     ! end (.not. xidfix)
   
     if (extfla) then

       ! fit only one free sigma in each run
         ntermf=ntermf+1 
!         ntfix=nsrc-1
!        (GL 07/05/2007) changed to:
         ntfix=ntfix-1
         nspar=nspar+1
       do n=1,nsrc
          noff=npsou*(n-1)
!         iordr(1)=0
!         call ordr(np,np,iordr)
          iordr=iordr0
         !fix all ext values to 0, only fit ext(n)
         do nn=1,nsrc
           if (nn .ne. n) then
             ioff=npsou*(nn-1)
             a(ioff+3)=0.0
             call ordr(np,ioff+3,iordr)
           endif
         enddo  
!         write(*,*) "n,1 pnt iordr:", n,",",iordr(1:28)
!         write(*,*) "n,1 pnt ntermf,ntfix:",n,ntermf,ntfix
         call pordr(np,a,afit,iordr,1)
         call pordr(np,deltaa,delfit,iordr,1)
         call pordr(np,sigmaa,sigfit,iordr,1)
           do nlauf=1,50
             flamda=1e-2    
             call mlfit(ntermf,afit,delfit,sigfit,iordr,xms,yms,ecut2, &
                                     flamda,yfit1,like0,lik_arr, nsrc, ntfix, ierr)
             if(abs(likold-like0).le.delt) then
               exit
             endif
             likold=like0 
           end do
         call pordr(np,a,afit,iordr,-1)                                   
         call pordr(np,deltaa,delfit,iordr,-1)                            
         call pordr(np,sigmaa,sigfit,iordr,-1)
         if (testoutput) write(*,*) "nlauf b)",nlauf
         if (testoutput) write(*,'(3F8.3,15F10.7)') a(1:18)
         if (testoutput) write(*,'(3F8.3,15F10.7)') a(18:36)
!        call system_clock(clock1,clock2,clock3) 
!        write(*,*) "ext 1 clock:",clock1-clock0     
         if (testoutput) write(*,*) "n,a(3),a(21),like0 ",n,a(3),a(21),like0
         asave(:,n)=a
         likesave(n)=like0
         lik_arr_save(:,n)=lik_arr

         ext_ml(n)=likesave(0)-like0
         ext_ml(n)=gammq(1.5,ext_ml(n))
!         New computation of ext_ml and its correction for N_dof (GL 17/06/05):
          if (testoutput)  write(*,*) "old ext_ml:",ext_ml(n)
          likediff=like00-like0
          do nn=1,nsrc
           do iimage=1,max_ima
             nzero=nzero+maskzero(nn,iimage)
           end do
          enddo                
          if (testoutput) then
            write(*,*) "corr. of ext_ml: ntermf,nffix,ntfix,nzero, nspar,nsrc:",ntermf,nffix,ntfix,nzero,nspar,nsrc
          endif
          ndof=ntermf
          likecorr=gammq(ndof/2.,likediff)
          ext_ml(n)=likecorr-like2dof(0)
          if (testoutput) write(*,*) "new definition ext_ml:",ext_ml(n)
          like2dof(n) = likecorr


 
         if (ext_ml(n) < dmlext .or. a(noff+3) < minext) then
           if (testoutput) write(*,*) "extent too small, ignore"
           ext_ml(n)=0
         endif

!!!!!!!!!  test: 09/06/2005 (GL): update  point source fit, if likelihood is better and  ext=0:
         if (like0 < likesave(0)  .and. a(noff+3) == 0.0) then
           asave(:,0)=a
           likesave(0)=like0
           lik_arr_save(:,0)=lik_arr
           nzero=0
           do nn=1,nsrc
           do iimage=1,max_ima
             nzero=nzero+maskzero(nn,iimage)
           end do
           enddo           
           if (testoutput) write(*,*) "(replace like2dof) nsrc,nspar-1,nband,nzero:", nsrc,nspar-1,nband,nzero
           likediff=like00-like0
           like2dof(0)=gammq(real(nsrc*(nspar-1+nband)-nzero)/2.,likediff)
         endif 

         if (ext_ml(n) < dmlext .or. a(noff+3) < minext) then
           if (testoutput) write(*,*) "no extent"
           ext_ml(n)=0
           !(05/04/2005 GL:)
           a(noff+3)=0.0
           !!!!!
         else
           if (n == 1) then 
             bestfit=1
             if (testoutput) write(*,*) "bestfit=1, a:",a(1:3),a(19:21)
           else if (like0 < likesave(bestfit)) then
             bestfit=n
             if (testoutput) write(*,*) "bestfit=n, n,a:",n,a(1:3),a(19:21)
           endif
         endif
!         write(*,*) "ext likelihood:",likesave(n)
       enddo
!      (nsrc)
!      (05/04/2005 GL:)
       do n=1,nsrc
         noff=npsou*(n-1)
!         write(*,*) "ext:",asave(noff+3,n)
         if (asave(noff+3,bestfit) < minext) then
           ext_ml(n)=0.0
         endif
       enddo
     if (testoutput) write(*,*) "end ext:",nsrc,a(1),a(2),a(3),ext_ml(1), ext_ml(2) 
!!!!!!!!
     endif 
!    (extfla)
!     call system_clock(clock1,clock2,clock3) 
!     write(*,*) "end extent clock:",clock1-clock0     


      a=asave(:,bestfit)     
      ntermf=ntermf0
      ntfix=ntfix0
! now calculate the likelihood of each of the sources
      do n=nsrc,1,-1
        iordr=iordr0
        ioff=npsou*(n-1)
        multflag=.false.
        if(nsrc.eq.1)then
! simply calculate likelihood for one source only
          do j=1,nim
            a(3+j)=0.
          end do
          call pordr(np,a,afit,iordr,1)
          call funct(afit,iordr,yfit1,yfit2,yfit3,nsrc,np,xms,yms,ecut2)
          call pordr(np,a,afit,iordr,-1)
          call like(like0,lik_arr,yfit1,yfit2)
        else
! check, if 2 sources have same position and extent:
          if (posfla) then
            do l=n-1,1,-1
              ioff1=npsou*(l-1)
              distsq=((a(ioff+1)-a(ioff1+1))**2+(a(ioff+2)-a(ioff1+2))**2)
              extdiff=abs(a(ioff+1)-a(ioff1+1))
              if (distsq < mindist .and. extdiff < minextdiff) then
                multflag=.true.
!                write(*,*) "source #, multflag:",n,multflag
                exit 
              endif
            enddo
          endif 
           
! zero flux of relevant component
          nffix=0
          if (posfla) then
            call ordr(ntermf,ioff+1,iordr)
            call ordr(ntermf,ioff+2,iordr)
              nffix=nffix+2
          end if
!          if (extfla .and. ext_ml(n) >= dmlext) then
          ! changed 15/11/04 GL
          if (extfla) then
            call ordr(ntermf,ioff+3,iordr)
            nffix=nffix+1
          end if
          do j=1,nim
            a(ioff+3+j)=0.
!  only call ordr, if maskzero=0 (changed 09/07/04)
            if (maskzero(n,j) .eq. 0) then  
              call ordr(ntermf,ioff+3+j,iordr)
              nffix=nffix+1
            endif
          end do
! fix parameters 


          call pordr(np,a,afit,iordr,1)
          call pordr(np,deltaa,delfit,iordr,1)
          call pordr(np,sigmaa,sigfit,iordr,1)
            do nlauf=1,50
              flamda=1e-2 
              call mlfit(ntermf-nffix,afit,delfit,sigfit,iordr,xms,yms, &
                         ecut2,flamda,yfit1,like0,lik_arr,nsrc,ntfix+nffix,ierr)
              if(abs(likold-like0).le.delt) exit                   
              likold=like0                                                    
            end do
            if (testoutput) write(*,*) "c) nlauf,like0:",nlauf,like0
!          endif  
          call pordr(np,a,afit,iordr,-1)
          call pordr(np,deltaa,delfit,iordr,-1)
          call pordr(np,sigmaa,sigfit,iordr,-1)                           
        endif
!  write(*,*) "iordr n"
   
!      write(*,*) "parameters c)"
!      write(*,'(3F8.3,6F15.7)') a(1:9)
!      write(*,*) "lik_arr(1:6):",lik_arr(1:6)
!      write(*,'(3F8.3,10F15.7)') a(19:36)
!      call system_clock(clock1,clock2,clock3) 
!      write(*,*) "clock c:",clock1-clock0      

        !dml(n)=like0-likmerk
        do j=1,nim 
!old:
!          exi_ml(j,n)=lik_arr(j)-lik_amerk(j)
!new:
           exi_ml(j,n)=lik_arr(j)-lik_arr_save(j,bestfit)
!           write(*,*) "exi_ml(j,n) , 1:", exi_ml(j,n)
        end do
!        fac=1.0
        nband=0
        dml(n)=0.         
        do j=1,num_instr
          nima=num_image(j)
          if (xid_arr(j)>0) nima=xid_arr(j)-1
          do i=1,nima
            ipoint=ip(j,i)
            dml(n)=dml(n)+exi_ml(ipoint,n)
            nband=nband+1
!            fac=fac*nband
          end do
        end do

        nzero=0
        do iimage=1,max_ima
          nzero=nzero+maskzero(n,iimage)
        end do

        likediff=like00-like0
        if (testoutput) write(*,*) "correction like0 dof:",ntermf,nffix,ntfix,nzero
        if (testoutput) write(*,*) "corrected like0:",ntermf,nffix,gammq(real(ntermf-nffix)/2.,likediff)
        if (testoutput) write(*,*) "corrected bestfit:",like2dof(bestfit)  
        

!        Calculate dml(n) from Ndof corrected likelihoods compared to like00:
         dml(n)=like2dof(bestfit)-gammq(real(ntermf-nffix)/2.,likediff) 
         if (testoutput) write(*,*) "new dml(n):",n,dml(n)
!!!!{
! 20/06/05
!        write(*,*) "detml raw:",dml(n)
!        dml(n)=gammq(real(nspar+nband-nzero)/2.,dml(n))
!        write(*,*) "detml corr:",n, nspar, nband, nzero, dml(n)
!!!!!}
        noff=npsou*(n-1)

!        write(*,*) "a:",a(noff+1),a(noff+2),a(noff+3)
!        special case: decision between 2 pnt sources and one extended source:
!        do not use dmlmin threshold in order to avoid bias towards extended source:
         dmlthresh=dmlmin
        if (extfla .and. nsrc == 2 .and.  bestfit == 0 .and. n == 2 .and. a(3) > minext) then
          likediff=like00-like0
          if (testoutput) write(*,*) "correction 1:",ntermf,ntfix,nffix,nspar,nband,nzero
          likecorr=gammq(real(nspar+nband-nzero)/2.,likediff)
          if (testoutput) write(*,*) "likecorr,like2dof(0):",likecorr,like2dof(0)
          if (likecorr < like2dof(0)) then
            dmlthresh=0.0
            if (testoutput) write(*,*) "set dmlthresh = 0, likecorr", likecorr
          endif
        endif
        if (extfla .and. nsrc == 2 .and.  bestfit == 0 .and. n == 1 .and. a(npsou+3) > minext) then
          likediff=like00-like0
          likecorr=gammq(real(nspar+nband-nzero)/2.,likediff)
          if (testoutput) write(*,*) "likecorr,like2dof(0):",likecorr,like2dof(0)
          if (likecorr < like2dof(0)) then
            dmlthresh=0.0
            if (testoutput) write(*,*) "set dmlthresh = 0, likecorr", likecorr
          endif
        endif
          


        if ((dml(n).lt. dmlthresh .or. multflag) .and. .not. xidfix) then
             if (testoutput) write(*,*) " throw out component:"
             if (testoutput) write(*,*) "a(1),a(2),a(3)",a(1),a(2),a(3)
             if (testoutput) write(*,*) "a(19),a(20),a(21)",a(19),a(20),a(21)
             if (testoutput) write(*,*) "n,dml(n):",n,dml(n)
! throw out component
            do l=n+1,nsrc
              ioff0=npsou*(l-2)
              ioff1=npsou*(l-1)
              do j=1,3
                a(ioff0+j)=a(ioff1+j)
              end do          
              do j=1,nim
                a(ioff0+3+j)=a(ioff1+3+j)
                exi_ml(j,l-1)=exi_ml(j,l)
              enddo
              dml(l-1)=dml(l)
              ext_ml(l-1)=ext_ml(l)
              insrc(l-1)=insrc(l)
            enddo
            nsrc=nsrc-1
            if(nsrc.eq.0)then
!              call system_clock(clock1,clock2,clock3)
!              write(*,*) "clock mulsou return1:", clock1-clock0
!               write(*,*) "return 1"
              return
            endif
          np=nsrc*npsou
          exit
        else  

! get back best-fit parameters
!          write(*,*) "get params from bestfit", bestfit
          do m=1,np
!            a(m)=amerk(m)
             a(m)=asave(m,bestfit)
          enddo
!          like0=likmerk
           like0=likesave(bestfit)
!          calculate final detection likelihoods for source (02/12/04, GL):
!          zero fluxes of source n:
           ioff=npsou*(n-1)
           do j=1,nim
             a(ioff+3+j)=0.
           end do
           if (testoutput) write(*,*) "d) n",n,np
           if (testoutput) write(*,'(3F8.3,15F10.7)') a(1:18)
           if (testoutput) write(*,'(3F8.3,15F10.7)') a(19:36) 
                    

           call pordr(np,a,afit,iordr,1)
           call funct(afit,iordr,yfit1,yfit2,yfit3,nsrc,np,xms,yms,ecut2)
           call pordr(np,a,afit,iordr,-1)
           call like(like1,lik_arr,yfit1,yfit2)
           if (testoutput) write(*,*) "like1",like1
           do j=1,nim 
             exi_ml(j,n)=lik_arr(j)-lik_arr_save(j,bestfit)
           end do
           nband=0
           dml(n)=0.         
           do j=1,num_instr
             nima=num_image(j)
             if (xid_arr(j)>0) nima=xid_arr(j)-1
             do i=1,nima
               ipoint=ip(j,i)
               dml(n)=dml(n)+exi_ml(ipoint,n)
               nband=nband+1
             end do
           end do
           if (extfla .and. ext_ml(n) == 0.0) then
             dml(n)=gammq(real(nspar-1+nband-nzero)/2.,dml(n))
           else
             dml(n)=gammq(real(nspar+nband-nzero)/2.,dml(n))
           endif
           if (testoutput) write(*,*) "d2)", n,nspar,nband,nzero,dml(n)
           do m=1,np
             a(m)=asave(m,bestfit)
           enddo           
          if (n == 1) done = .true.
        endif
      enddo
     end do 

!   write(*,*) "final params:" 
!   write(*,'(3F8.3,15F10.7)') a(1:18)
!   write(*,'(3F8.3,15F10.7)') a(19:36) 

!     write(*,*) "dml(1),dml(2):",dml(1),dml(2)

!  assign output parameter values before error loop (GL 12/11/2004):
 
   do i=1,nsrc
    ioff=npsou*(i-1)
    xms(i)=a(ioff+1)
    yms(i)=a(ioff+2)
    sigma(i)=a(ioff+3)
    do j=1,nim
      scts(j,i)=a(ioff+3+j)
    end do
   enddo  

  
  ! second stage will be run, return to main program:
!  write(*,*) "first, ext:",first,ext_ml(1:nsrc)
  if (first .and. maxval(ext_ml(1:nsrc)) .gt. 0.0) then
!    call system_clock(clock1,clock2,clock3)
!    write(*,*) "clock mulsou 2:", clock1-clock0    
    return
  endif

!    call system_clock(clock1,clock2,clock3)
!    write(*,*) "clock mulsou end fitting:", clock1-clock0   


! call "model" to calculate PSF weighted mask fraction:
      psffrac=0.0
      iordr(1)=0
      call ordr(np,np,iordr)
      call pordr(np,a,afit,iordr,1)
      ! call funct with scts set to 1.0:
      do i=1,nsrc
       ioff=npsou*(i-1)
        do j=1,nim
         afit(ioff+3+j)=1.0
        end do
      enddo        
      call funct(afit,iordr,yfit1,yfit2,yfit3,nsrc,np,xms,yms,ecut2)
      call model(yfit1,yfit2,yfit3,xms,yms,sigma,scts,nsrc,ecut2,.true.) 
      


! throw out sources with PSF weighted mask fraction psffrac < psfthreshold
  do n=nsrc,1,-1
    nn=0
    ioff=npsou*(i-1)
    do i=1,num_instr
      ! check for psffrac values below the threshold:
      maskbad=.FALSE.
      do j=1,num_image(i)
        ipoint=ip(i,j)
        if (psffrac(n,ipoint) < psfthreshold .and. .not. xidfix) maskbad=.TRUE.
      enddo
      do j=1,num_image(i)   
        ipoint=ip(i,j) 
        if (.not. maskbad) then
          nn=nn+1  
        else
          ! throw out source, if psffrac < psfthreshold in all energy bands:
          scts(ipoint,n)=0.0
          exi_ml(ipoint,n)=0.0
          if  (maskzero(n,ipoint) == 0) then 
            nzero=nzero+1 
            maskzero(n,ipoint)=1
          endif
        endif
      end do
    end do
!   check likelihood once more:

    dml(n)=0.0
    do j=1,nim
      if (maskzero(n,j) == 0) dml(n)=dml(n)+exi_ml(j,n)
    enddo
    if (extfla .and. ext_ml(n) == 0.0) then
      dml(n)=gammq(real(nspar-1+nband-nzero)/2.,dml(n))
    else
      dml(n)=gammq(real(nspar+nband-nzero)/2.,dml(n))
    endif
!    write(*,*) xms(1),yms(1),nn
    if ((nn == 0 .or. dml(n) .lt. dmlmin) .and. .not. xidfix) then
    ! throw out component:
       do l=n+1,nsrc
         ioff0=npsou*(l-2)
         ioff1=npsou*(l-1)
         do j=1,3
           a(ioff0+j)=a(ioff1+j)
         end do
         xms(l-1)=xms(l)
         yms(l-1)=yms(l)
         sigma(l-1)=sigma(l)          
         do j=1,nim
           a(ioff0+3+j)=a(ioff1+3+j)
           exi_ml(j,l-1)=exi_ml(j,l)
           scts(j,l-1)=scts(j,l)
           ! also copy psffrac and maskzero (GL 02/08/06): 
           psffrac(l-1,j)=psffrac(l,j)
           maskzero(l-1,j)=maskzero(l,j)
         enddo
         dml(l-1)=dml(l)
         ext_ml(l-1)=ext_ml(l)
         insrc(l-1)=insrc(l)
       enddo
       nsrc=nsrc-1
       if (nsrc.eq.0) return       
    endif
  enddo



! error loop begins   
      if (errfla) then

        iordr(1)=0
        call ordr(np,np,iordr)                                           
 
! now position errors for position fixing
!       npsou=nim+nspar
!        write(*,*) "calc. errors" 
        do i=1,nsrc
          do j=1,npsou
             if (j >= 4) then
               ipoint=j-3 
             else
               ipoint=1
             endif 
             if (j <= 2 .and. posfla .or. &
                j == 3 .and. extfla .and. ext_ml(i)>=dmlext .or. &
                j >= 4 .and.  maskzero(i,ipoint) == 0) then

              ifel=npsou*(i-1)+j

              call ordr(np,ifel,iordr)

              flamda=1.0e-2
              call pordr(np,a,afit,iordr,1)
! test smaller delta values for pos parameters (22/06/06)
!              call pordr(np,deltaa,delfit,iordr,1)
              call pordr(np,deltae,delfit,iordr,1)
              call pordr(np,sigmaa,sigfit,iordr,1)
              call felsu(np,afit,delfit,sigfit,iordr,xms,yms, &
                         flamda,nsrc,like0,fello,felhi,np,ecut2)
              call pordr(np,a,afit,iordr,-1)
!              call pordr(np,deltaa,delfit,iordr,-1)
              call pordr(np,deltae,delfit,iordr,-1)
              call pordr(np,sigmaa,sigfit,iordr,-1)
              if (fello .le. 0) then
                ! if lower error is set to 0, use felhi as error
                fe(ifel)=max(felhi,0.)
              else                
                fe(ifel)=0.5*(max(fello,0.)+max(felhi,0.))
              endif
            end if
          end do
        end do
      
      else
        fe = 0.
      end if

                                                                     
! assign output values
      do i=1,nsrc
        ioff=npsou*(i-1)
!        xms(i)=a(ioff+1)
        exms(i)=fe(ioff+1)
!        yms(i)=a(ioff+2)
        eyms(i)=fe(ioff+2)
!        sigma(i)=a(ioff+3)
        if (sigma(i) .gt. 0.) then
          esigma(i)=fe(ioff+3)
        else
          esigma(i)=0.
        end if 
        do j=1,nim
!          scts(j,i)=a(ioff+3+j)
!         set counts error to 0.0, if source was thrown out due to psffrac limit (GL 27/02/06) 
          if (maskzero(i,j) == 0) then
            escts(j,i)=fe(ioff+3+j)
          else
            escts(j,i)=0.0
          endif
        end do


        cos_pa = dcos(crota2 * pi/180d0)
        sin_pa = dsin(crota2 * pi/180d0)
        xr = (xms(i)-crpix1) * crdelt1 * pi/180d0
        yr = (yms(i)-crpix2) * crdelt2 * pi/180d0
        dra =  xr * cos_pa - yr * sin_pa
        ddec = xr * sin_pa + yr * cos_pa
        r0r = crval1 * pi/180d0
        d0r = crval2 * pi/180d0
        call antisp(dra,ddec,r0r,d0r,rr,dr)
        ra(i) = rr * 180d0/pi
        dec(i) = dr *180d0/pi
        eradec(i)  = sqrt(exms(i)**2+eyms(i)**2) * pixim



        call sla_EQGAL(rr,dr,lr,br)
        lii(i) = lr * 180d0/pi
        bii(i) = br * 180d0/pi

      enddo

!      write(*,*) "final coords:"
!       write(*,'(4F8.3)') xms(1),yms(1),xms(2),yms(2)



! get raw coordinates
      call rawcoords(ra,dec,nsrc,datetime, &
                     chipix, chipiy, ccdinr, offax, azim)
!---------- JR; testing ---------------------------------
!      write(*,*)ra(1),dec(1),offax(1,1),azim(1,1)
!--------------------------------------------------------
!      write(*,*) "offax:",offax(1:3,1)
      srcontime=-99.9
      do n=1,nsrc
        do i=1,num_instr
          do j=1,num_image(i)
            ipoint=ip(i,j)
            l=expip(i)
             if (ccdinr(i,n) > 0 .and. maskzero(n,ipoint) == 0) then 
               srcontime(ipoint,n)=ontime(ccdinr(i,n),ipoint)
             else
               srcontime(ipoint,n)=-99.9
             endif
          enddo
        enddo
      enddo   

  
vignetting(:,:)=0.0
effarea_cen=0.0
effarea_src=0.0
! calculate vignetting:
      do n=1,nsrc
        do i=1,num_instr
          do j=1,num_image(i)
            ipoint=ip(i,j)
            ene=energy(ipoint)
            if (expip(i) == 1) call CAL_setState(instrument=EPN,AccuracyLevel=ACCURACY_MEDIUM)
            if (expip(i) == 2) call CAL_setState(instrument=EMOS1,AccuracyLevel=ACCURACY_MEDIUM)
            if (expip(i) == 3) call CAL_setState(instrument=EMOS2,AccuracyLevel=ACCURACY_MEDIUM)
!           effarea_cen=CAL_getEffectiveArea(dble(ene),0d0,0d0)
!           write(*,*) "effarea:",effarea_cen
             vignetting(ipoint,n)=CAL_getVignettingFactor(dble(ene),offax(i,n),azim(i,n))
          enddo
        enddo
      enddo   


! update background map
!      write(*,*) "bg_map, nsrc:", nsrc
      if (testoutput) write(*,*) "bg_map, src1:",xms(1),yms(1),sigma(1),ext_ml(1),scts(1:5,1)
      if (testoutput) write(*,*) "bg_map, src2:",xms(1),yms(2),sigma(2),ext_ml(2),scts(1:5,2)



      l=1
      do i=1,num_instr
        do j=1,num_image(i)
          ipoint=ip(i,j)
          ene=energy(ipoint)
          do n=1,nsrc
            ! avoid extended source in bg map, where pnt source is written to source list (15/10/04):
            if (ext_ml(n) .eq. 0.0 .and. .not. (xidfix .or. randomflag)) sigma(n) = 0 
            ix0=xms(n)
            iy0=yms(n)
            exp=0.
            expn=0. 
!!-- test JR --------------------------
!            testsum =0.
!!-------------------------------------           
            do ix=ix0-irad,ix0+irad
              do iy=iy0-irad,iy0+irad
               if ((ix-ix0)**2+(iy-iy0)**2<irad**2) then
                if (ix>=1.and.ix<=npix(1).and.iy>=1.and.iy<=npix(2)) then
                  x1=ix
                  y1=iy 
                  if ((x1-xms(n))**2+(y1-yms(n))**2<ical**2) then
!                    if (point_resp(i) .ge. 1 .and. point_resp(i) .le. 3) then
!                        bg_image(ix,iy,ipoint) =  bg_image(ix,iy,ipoint) + &
!                         scts(ipoint,n) * &
!                         psf1(point_resp(i),energy,j,ix,iy, &
!                         xms(n)-xoff(expip(i)),yms(n)-yoff(expip(i)), &
!                         xcen(i),ycen(i),sigma(n),rcal) * &
!                         exp_image(ix,iy,ipoint)
!                       exp = exp + & 
!                         psf1(point_resp(i),energy,j,ix,iy, &
!                         xms(n)-xoff(expip(i)),yms(n)-yoff(expip(i)), &
!                         xcen(i),ycen(i),sigma(n),rcal) * &
!                         exp_image(ix,iy,ipoint)
!                       expn = expn + &
!                         psf1(point_resp(i),energy,j,ix,iy, &
!                         xms(n)-xoff(expip(i)),yms(n)-yoff(expip(i)), &
!                         xcen(i),ycen(i),sigma(n),rcal)
!                     else if (point_resp(i) .eq. 4) then 
!                        bg_image(ix,iy,ipoint) =  bg_image(ix,iy,ipoint) + &
!                         scts(ipoint,n)*psf1(1,energy,j,ix,iy, &
!                         xms(n)-xoff(expip(i)),yms(n)-yoff(expip(i)), &
!                         xcen(i),ycen(i),sigma(n),rcal) * &
!                         exp_image(ix,iy,ipoint)
!                       exp = exp + & 
!                         psf1(1,energy,j,ix,iy, &
!                         xms(n)-xoff(expip(i)),yms(n)-yoff(expip(i)), &
!                         xcen(i),ycen(i),sigma(n),rcal) * &
!                         exp_image(ix,iy,ipoint)
!                       expn = expn + &
!                         psf1(1,energy,j,ix,iy, &
!                         xms(n)-xoff(expip(i)),yms(n)-yoff(expip(i)), &
!                         xcen(i),ycen(i),sigma(n),rcal)
!                     else
!                        call error("WrongPSF","Wrong PSF number") 
!                     endif 
                    select case (point_resp(i))       
                      case(1)
!!-- test JR -------------------------------------------------------------------------------
!                      testsum = testsum+psf1(energy,ipoint,ix,iy, &
!                         xms(n)-xoff(expip(i)),yms(n)-yoff(expip(i)), &
!                         sigma(n),rcal,offax,azim,n)
!!------------------------------------------------------------------------------------------
                      bg_image(ixb(ix,ipoint),iyb(iy,ipoint),ipoint) = &        !(JR)
                         bg_image(ixb(ix,ipoint),iyb(iy,ipoint),ipoint) + &     !(JR)
                         scts(ipoint,n) * &
                         psf1(energy,ipoint,ix,iy, &
                         xms(n)-xoff(expip(i)),yms(n)-yoff(expip(i)), &
                         sigma(n),rcal,offax,azim,n) * &
                         exp_image(ixb(ix,ipoint),iyb(iy,ipoint),ipoint)        !(JR)
                       exp = exp + & 
                         psf1(energy,ipoint,ix,iy, &
                         xms(n)-xoff(expip(i)),yms(n)-yoff(expip(i)), &
                         sigma(n),rcal,offax,azim,n) * &
                         exp_image(ixb(ix,ipoint),iyb(iy,ipoint),ipoint)        !(JR)
                       expn = expn + &
                         psf1(energy,ipoint,ix,iy, &
                         xms(n)-xoff(expip(i)),yms(n)-yoff(expip(i)), &
                         sigma(n),rcal,offax,azim,n)
                      case(2)
!!-- test JR -------------------------------------------------------------------------------
!                      testsum = testsum+psf1(energy,ipoint,ix,iy, &
!                         xms(n)-xoff(expip(i)),yms(n)-yoff(expip(i)), &
!                         sigma(n),rcal,offax,azim,n)
!!------------------------------------------------------------------------------------------
                      bg_image(ixb(ix,ipoint),iyb(iy,ipoint),ipoint) = &        !(JR)
                         bg_image(ixb(ix,ipoint),iyb(iy,ipoint),ipoint) + &     !(JR)
                         scts(ipoint,n)*psf2(energy,ipoint,ix,iy, &
                         xms(n)-xoff(expip(i)),yms(n)-yoff(expip(i)), &
                         sigma(n),rcal,offax,azim,n) * &
                         exp_image(ixb(ix,ipoint),iyb(iy,ipoint),ipoint)        !(JR)
                       exp = exp + & 
                         psf2(energy,ipoint,ix,iy, &
                         xms(n)-xoff(expip(i)),yms(n)-yoff(expip(i)), &
                         sigma(n),rcal,offax,azim,n) * &
                         exp_image(ixb(ix,ipoint),iyb(iy,ipoint),ipoint)        !(JR)
                       expn = expn + &
                         psf2(energy,ipoint,ix,iy, &
                         xms(n)-xoff(expip(i)),yms(n)-yoff(expip(i)), &
                         sigma(n),rcal,offax,azim,n)
                      case(3)
!!-- test JR -------------------------------------------------------------------------------
!                      testsum = testsum+psf1(energy,ipoint,ix,iy, &
!                         xms(n)-xoff(expip(i)),yms(n)-yoff(expip(i)), &
!                         sigma(n),rcal,offax,azim,n)
!!------------------------------------------------------------------------------------------
                      bg_image(ixb(ix,ipoint),iyb(iy,ipoint),ipoint) = &        !(JR)
                         bg_image(ixb(ix,ipoint),iyb(iy,ipoint),ipoint) + &     !(JR)
                         scts(ipoint,n)*psf3(energy,ipoint,ix,iy, &
                         xms(n)-xoff(expip(i)),yms(n)-yoff(expip(i)), &
                         sigma(n),rcal,offax,azim,n) * &
                         exp_image(ixb(ix,ipoint),iyb(iy,ipoint),ipoint)        !(JR)
                       exp = exp + & 
                         psf3(energy,ipoint,ix,iy, &
                         xms(n)-xoff(expip(i)),yms(n)-yoff(expip(i)), &
                         sigma(n),rcal,offax,azim,n) * &
                         exp_image(ixb(ix,ipoint),iyb(iy,ipoint),ipoint)        !(JR)
                       expn = expn + &
                         psf3(energy,ipoint,ix,iy, &
                         xms(n)-xoff(expip(i)),yms(n)-yoff(expip(i)), &
                         sigma(n),rcal,offax,azim,n)
                      case(4)
                     bg_image(ixb(ix,ipoint),iyb(iy,ipoint),ipoint) = &         !(JR)
                         bg_image(ixb(ix,ipoint),iyb(iy,ipoint),ipoint) + &     !(JR)
                         scts(ipoint,n)*psf1(energy,ipoint,ix,iy, &
                         xms(n)-xoff(expip(i)),yms(n)-yoff(expip(i)), &
                         sigma(n),rcal,offax,azim,n) * &
                         exp_image(ixb(ix,ipoint),iyb(iy,ipoint),ipoint)        !(JR)
                       exp = exp + & 
                         psf1(energy,ipoint,ix,iy, &
                         xms(n)-xoff(expip(i)),yms(n)-yoff(expip(i)), &
                         sigma(n),rcal,offax,azim,n) * &
                         exp_image(ixb(ix,ipoint),iyb(iy,ipoint),ipoint)        !(JR)
                       expn = expn + &
                         psf1(energy,ipoint,ix,iy, &
                         xms(n)-xoff(expip(i)),yms(n)-yoff(expip(i)), &
                         sigma(n),rcal,offax,azim,n)
                      case default
                        call error("WrongPSF","Wrong PSF number") 
                    end select      
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!               
                  else 
                   bg_image(ixb(ix,ipoint),iyb(iy,ipoint),ipoint) = &
                   bg_image(ixb(ix,ipoint),iyb(iy,ipoint),ipoint) + &
                       scts(ipoint,n)*psf4(energy,j,x1,y1, &
                       xms(n)-xoff(expip(i)),yms(n)-yoff(expip(i)), &
                       xcen(i),ycen(i),sigma(n),rcal,offax(i,n)) * &
                       exp_image(ixb(ix,ipoint),iyb(iy,ipoint),ipoint)
                  end if
                end if
               end if
              end do
            end do
!!-- test JR -------------------------------------------------------------------------------
!            write(*,*) "Normalization for source:", n , testsum
!!------------------------------------------------------------------------------------------
            rate(ipoint,n)=scts(ipoint,n)
            erate(ipoint,n)=escts(ipoint,n)
            scts(ipoint,n)=scts(ipoint,n)*exp/expn     
            escts(ipoint,n)=escts(ipoint,n)*exp/expn
            srcexpos(ipoint,n)=0.0
            if (expn > 0.0) srcexpos(ipoint,n)=exp/expn
!            write(*,*) "bgimage",srcexpos(ipoint,n)
          end do 
         end do
      end do
!   copy fit parameters to single precision output parameters
      do i=1,max_fit
        sxms(i)=sngl(xms(i))
        syms(i)=sngl(yms(i))
        ssigma(i)=sngl(sigma(i))
        do j=1,max_ima
          sscts(j,i)=sngl(scts(j,i))
        enddo
      enddo

   


!  call system_clock(clock1,clock2,clock3)
!  write(*,*) "clock end mulsou :", clock1-clock0



!      write(*,*) "count_model:", count_model
!       write(*,*) " count_psf:", count_psf                                    
      end subroutine mulsou   



  !----------------------------------------------------------------------
  subroutine ordr(nterms,nfix,iordr)
  !----------------------------------------------------------------------

    integer     i,iordr(max_par),io(max_par),nfix,nnfix,nterms

    if(iordr(1).eq.0)then
      do i=1,max_par
        iordr(i)=i
      end do
    endif

    do i=1,max_par
      if(iordr(i).eq.nfix) exit
      io(i)=iordr(i)
    end do

    nnfix=i

    do i=nnfix,nterms-1
      io(i)=iordr(i+1)
    end do

    io(nterms)=nfix

    if(nterms.ne.max_par) then
      do i=nterms+1,max_par
        io(i)=iordr(i)
      end do
    end if 

    iordr(1:max_par)=io(1:max_par)

  end subroutine ordr

  !----------------------------------------------------------------------
  subroutine pordr(nterms,a,b,iordr,mode)
  !----------------------------------------------------------------------

    real(kind=double) :: a(max_par),b(max_par)
    integer       i,mode,nterms,iordr(max_par)

    if(mode.eq.1) then
      do i=1,nterms
        b(i)=a(iordr(i))
      enddo
    else

! andere richtung
      do i=1,nterms
        a(iordr(i))=b(i)
      enddo
    end if

  end subroutine pordr

  !----------------------------------------------------------------------
  function cage(array,n,vallo,valhi)
  !----------------------------------------------------------------------

    real(kind=double) ::        array(max_par),cage,value
    real ::                     vallo,valhi
    integer ::     ierr,n 

    ierr=0
!
! used to cage fit parameters to reasonable values
    value=array(n)

    if (value.lt.vallo) then
      array(n)=vallo
!      write(6,*)' allowed values ',vallo,valhi
    else if (value.gt.valhi) then
      array(n)=valhi
!      write(6,*)' allowed values ',vallo,valhi
    endif
    cage=array(n)

  end function cage    
      
  !----------------------------------------------------------------------
  subroutine cagexy (x1,y1,x0,y0,rcut2)
  !----------------------------------------------------------------------

    real(kind=double) :: x0,y0,x1,y1
    real     rcut2  
    real     ds

    ds=sqrt(((x1-x0)**2+(y1-y0)**2)/rcut2)
    if (ds.gt.1.) then
      x1 = x0+(x1-x0)/ds
      y1 = y0+(y1-y0)/ds
    end if
 
  end subroutine cagexy

  !----------------------------------------------------------------------
  subroutine like(lik,lik_arr,yfit1,yfit2)
  !----------------------------------------------------------------------

    real, dimension(max_events), intent(in) :: yfit1
    real, dimension(max_ima), intent(in) :: yfit2

    real(kind=double), dimension(max_ima), intent(out) :: lik_arr
    real(kind=double), intent(out) :: lik

    integer :: k,ipoint 

! accumulate statistics
    lik_arr(1:nim)=0.
    !loop over image pixels
    do k=1,npts
      ipoint=event(k)%ipt
      lik_arr(ipoint)=lik_arr(ipoint)+event(k)%n*log(max(yfit1(k),1e-30))
!!! try to prevent sources running into negative fluxes: 
     if (yfit1(k) < 0.0) then
         lik_arr(ipoint)=lik_arr(ipoint)-1.
    endif
!!!!!!! 
    end do

!!!!!!!    lik_arr(1:nim)=lik_arr(1:nim)-yfit2(1:nim)


    lik_arr(1:nim)=lik_arr(1:nim)-max(yfit2(1:nim),0.0)

!    lik_arr(1:nim)=-2.*lik_arr(1:nim)
!    remove factor 2 from ML => ML=-ln(P)
     lik_arr(1:nim)=-lik_arr(1:nim)

    lik=0. 
    do ipoint=1,nim
      lik=lik+lik_arr(ipoint)
    end do 


!     write(*,*) "yfit2", lik, yfit2(1:nim)


!   write(*,*) "like:",lik

   end subroutine like

  !----------------------------------------------------------------------
  subroutine mlfit(nterms,a,deltaa,sigmaa,iordr,xms,yms,ecut2,flamda, &
                   yfit1,like0,lik_arr,is,nfel,ierr)
  !----------------------------------------------------------------------

    integer :: i,j,k,minmethod
    integer :: ntermf,nterms,nfree,nfel,is,ierr,iordr(max_par)
    real(kind=double) :: det
    real(kind=double) :: a(max_par),deltaa(max_par),sigmaa(max_par),b(max_par)
    real(kind=double) :: xms(max_fit),yms(max_fit)
    real :: yfit1(max_events),ytemp1(max_events)
    real :: yfit2(max_ima),yfit3,ytemp3
    real(kind=double) :: lik_arr(max_ima),like0,like1,like2,like3, like12
    !! real :: derv1(max_par,max_events),derv3(max_par)
    real :: derv3(max_par),testsig
    real, allocatable :: derv1(:,:)
    real :: aj,ak,delta,delta2,deltak,ecut2,flamda
    real(kind=double) ::array(max_par,max_par),alpha(max_par,max_par), &
                        beta(max_par)      

    real, parameter :: small = 1e-6
    real :: test1,test2

!   small=tiny(small)  

    !allocate(derv1(max_par,max_events))
    allocate(derv1(nterms,npts))

    ntermf=nterms+nfel
    nfree=npts-nterms
    if (nfree.le.0) &
      call error("FitFailed","degrees of freedom less or equal 0")




!!!!!!!!!! insert 9/12/2003 !!!
    minmethod = 2


    if (minmethod .eq. 1) then 

       testsig=1.0

       beta(1:nterms)=0.
       alpha(1:nterms,1:nterms)=0. 

       call funct(a,iordr,yfit1,yfit2,yfit3,is,nterms+nfel,xms,yms,ecut2)
       call like(like0,lik_arr,yfit1,yfit2)        
       do j=1,nterms
         aj=a(j)
         delta=deltaa(j)
         delta2=2.*deltaa(j) 
         a(j)=aj+delta 
         call funct(a,iordr,yfit1,yfit2,yfit3,is,nterms+nfel,xms,yms,ecut2)
         call like(like1,lik_arr,yfit1,yfit2)
         a(j)=aj-delta 
         call funct(a,iordr,yfit1,yfit2,yfit3,is,nterms+nfel,xms,yms,ecut2)
         call like(like2,lik_arr,yfit1,yfit2)
         like12=like1-like2
         a(j)=aj      
         beta(j)=testsig*(-1.)*like12/delta2 
         alpha(j,j)=testsig*(like12-2.*like1+like0)/(delta*delta)
   ! derivatives del^2(like)/(del_ak del_aj) = ( like(aj + daj,ak+dak) - like(aj + daj,ak) - like(aj, ak+dak) + like(aj,ak) )/(daj*daj)          
         do k=1,j-j 
            ak=a(k)
            deltak=5*deltaa(k)
            a(k)=ak+deltak
            a(j)=aj+delta
            call funct(a,iordr,yfit1,yfit2,yfit3,is,nterms+nfel,xms,yms,ecut2)
            call like(like2,lik_arr,yfit1,yfit2)
            a(j)=aj
            call funct(a,iordr,yfit1,yfit2,yfit3,is,nterms+nfel,xms,yms,ecut2)
            call like(like3,lik_arr,yfit1,yfit2)
            alpha(j,k)=testsig*(like2-like1-like3+like0)/(delta*deltak)
            a(k)=ak
         end do
         do  k=1,j-1
           alpha(k,j)=alpha(j,k)
         end do
       end do
     else 
     !minmethod > 1

!!!!!!!!!! end insert 9/12/2003

!!!!!!! remove 9/12/2003 and replace with numerical alpha/ beta matrices"

    do j=1,nterms
      aj=a(j)

      delta=deltaa(j)
      delta2=2.0*delta

      a(j)=aj+delta

      call funct(a,iordr,yfit1,yfit2,yfit3,is,nterms+nfel,xms,yms,ecut2)

      a(j)=aj-delta
      call funct(a,iordr,ytemp1,yfit2,ytemp3,is,nterms+nfel,xms,yms,ecut2)

      derv1(j,1:npts)=(yfit1(1:npts)-ytemp1(1:npts))/delta2
      derv3(j)=(yfit3-ytemp3)/delta2
!      write(*,*) "j,derv1,derv3,delta2",j,derv1(j,1:npts),derv3(j),delta2
!      write(*,*) "a(1:7)",a(1:7) 

      a(j)=aj
    end do
!    
    beta(1:nterms)=0.
    alpha(1:nterms,1:nterms)=0.          
!
! write(*,*) "mlfit i)"
    call funct(a,iordr,yfit1,yfit2,yfit3,is,nterms+nfel,xms,yms,ecut2)
!
!      !      do i=1,npts
!      !       do j=1,nterms 
!      !          beta(j)=beta(j)+(event(i)%n/yfit1(i)*derv1(j,i)  &
!      !                                                     -derv3(j))
!      !          do k=1,j 
!      !            alpha(j,k)=alpha(j,k)+ &
!      !                   event(i)%n/yfit1(i)**2*derv1(j,i)*derv1(k,i)
!      !          end do
!      !        end do
!      !      end do
!
     do i=1,npts
       do j=1,nterms
!      !        beta(j)=beta(j)+(event(i)%n-yfit1(i))/max(event(i)%n,1)*derv1(j,i) 
        if (yfit1(i) .ne.  0.0) beta(j)=beta(j)+(event(i)%n-yfit1(i))/yfit1(i)*derv1(j,i)
        do k=1,j 
!      !         alpha(j,k)=alpha(j,k)+derv1(j,i)*derv1(k,i)/max(event(i)%n,1)
      
          if (yfit1(i) .ne.  0.0) alpha(j,k)=alpha(j,k)+derv1(j,i)*derv1(k,i)/yfit1(i)
        end do
      end do
    end do

    do j=1,nterms
      do k=1,j
        alpha(k,j)=alpha(j,k)
      end do
    end do
  endif
!!!! 9/12/2003
! write(*,*) "mlfit j)"
    call funct(a,iordr,yfit1,yfit2,yfit3,is,nterms+nfel,xms,yms,ecut2)
    call like(like1,lik_arr,yfit1,yfit2)
! write(*,*) "mlfit j) done"
    do
      
      do j=1,nterms
        do k=1,nterms
          if(j.eq.k)then
            array(j,k)=1.0d0
          else 
            array(j,k)=alpha(j,k)/dsqrt(dabs(alpha(j,j))+small) &
                                 /dsqrt(dabs(alpha(k,k))+small)
          endif
        end do
        array(j,j)=1.0d0+flamda
      end do
  
      call mati(array,nterms,det)

!      b(1:nterms)=a(1:nterms)
      b = a
      
      do j=1,nterms
        do k=1,nterms
          b(j)=b(j)+beta(k)*array(j,k)/dsqrt(dabs(alpha(j,j))+small) &
                                      /dsqrt(dabs(alpha(k,k))+small)
!        write(*,*) "matrix:",j,k,beta(k),array(j,k),alpha(j,j),alpha(k,k)
        end do 
      end do

      if (.not. (beta(1) .gt. -1.E10)) then
!         write(*,*) array(1:nterms,1:nterms)
         stop
      endif

! write(*,*) "k)"
!!!! test output write(*,*):
!      if (.not.  ((b(1) >= 0.0) .or. (b(1) < 0.0))) then
!         write(*,*) "b:", b(1:10)
!         write(*,*) "beta:", beta(1:10)
!      do j=1,nterms
!        do k=1,nterms
!          write(*,*) "array:",j,k,array(j,k)
!          write(*,*) "alpha:",j,j,alpha(j,j)
!         write(*,*) "alpha:",k,k,alpha(k,k)
!          write(*,*) "sqrt:", j,k, dsqrt(dabs(alpha(j,j))+small) * dsqrt(dabs(alpha(k,k))+small)
!          write(*,*) "derv1:",j,k,derv1(j,k),yfit1(j)
!        write(*,*) "matrix:",j,k,beta(k),array(j,k),alpha(j,j),alpha(k,k)
!        end do 
!      end do
!      stop
!      endif 
      

!!!!!!!!!!!!!!!!!! end test output

      call funct(b,iordr,yfit1,yfit2,yfit3,is,nterms+nfel,xms,yms,ecut2)
      call like(like0,lik_arr,yfit1,yfit2)

      if (like0-like1.lt.0.) then
        exit
      else
        flamda=10.*flamda
        if (flamda.ge.1e10) exit
      end if

    end do

    a(1:nterms)=b(1:nterms)
    do j=1,nterms
      sigmaa(j)=dsqrt(dabs(array(j,j))/(dabs(alpha(j,j))+small))
    end do
    flamda=flamda/10.

    deallocate (derv1)


 


  end subroutine mlfit

  !----------------------------------------------------------------------
  subroutine funct(afit,iordr,yfit1,yfit2,yfit3,is,np,xms,yms,ecut2)
  !------------------------------------------------------------------------
      
    real :: yfit1(max_events),yfit2(max_ima),yfit3, & 
            ecut2,ecut

    real(kind=double) :: a(max_par),afit(max_par), x0(max_fit),y0(max_fit), &
                         sig(max_fit),scts(max_ima,max_fit), xms(max_fit),yms(max_fit)

    integer :: i,n,ierr,iordr(max_par),is,np, &
               ndat,npars

    ierr = 0

    call pordr(np,a,afit,iordr,-1)                               

    ecut = sqrt(ecut2)

! cage parameters
    npars=nim+3
!    write(*,*) '*****a:',a(1:14)
    do n=1,is 
      ndat=(n-1)*npars+1
      call cagexy (a(ndat),a(ndat+1),xms(n),yms(n),ecut2)
      x0(n)=a(ndat)
      y0(n)=a(ndat+1)
      ndat=(n-1)*npars+3
      sig(n)=cage(a,ndat,0.,maxext)
      do i=1,nim
        ndat=(n-1)*npars+i+3
!!!!!!!!!!!!!!!!!!!!!
        if (negfla) then 
          scts(i,n)=cage(a,ndat,-1.0,1e10)
        else
           scts(i,n)=cage(a,ndat,0.0,1e10) 
        endif
!         if  (scts(i,n) .eq. 0) then
!           write(*,*)  i,n, scts(i,n), x0(n),y0(n)
!         endif
!         scts(i,n)=cage(a,ndat,-1.,1e10)
!!!!!!!!!!!!!!!!!!!!!!
      end do
    end do 

! calculate expectation value of model + background

    call model(yfit1,yfit2,yfit3,x0,y0,sig,scts,is,ecut,.false.)

    call pordr(np,a,afit,iordr,1)                                

  end subroutine funct
           
  !----------------------------------------------------------------------
  subroutine model(yfit1,yfit2,yfit3,x0,y0,sig,scts,is,ecut,last)
  !----------------------------------------------------------------------
    
   
    real, dimension(max_events), intent(out) :: yfit1
    real, dimension(max_ima), intent(out) :: yfit2
    real, intent(out) :: yfit3
!    real, dimension(max_ima,max_fit,max_mask,max_mask), SAVE :: psf_save
    real, dimension(:,:,:,:), allocatable, SAVE :: psf_save
    real, dimension(:,:,:,:), allocatable, SAVE :: ff_save
    real, dimension(max_mask,max_mask) :: modelima

    real(kind=double), dimension(max_fit),  intent(in) :: x0, y0, sig
    real(kind=double), dimension(max_ima,max_fit), intent(in) :: scts
!    logical, dimension(max_ima,max_fit) :: scts_ch 
!    logical, dimension(max_fit) ::  x0_ch, y0_ch, sig_ch

    real, dimension(max_ima,max_fit), SAVE :: scts_save
    real, dimension(max_ima,max_fit) :: scts_scale
    real(kind=double), dimension(max_fit), SAVE  :: x0_save, y0_save, sig_save
!    real, dimension(max_ima,max_fit), intent(out) :: detcounts, srcexpos
    real :: src_rate
    real, intent(in) :: ecut
    integer, intent(in) :: is
    integer, SAVE :: filenum=0
    character*4 :: filestring    

    real :: totmodel,maskmodel
  
    real :: small
    real(kind=double) :: xremain,yremain
    real :: ene,x1,y1,ene_old
    real :: s1,s2,s3,fudge,stemp
    integer :: i,j,ii,jj,jpoint,l,n,ix,iy,ix0,ix1,iy0,iy1,ixx,iyy,ipoint,tempsum,xx0,yy0,ifound
    integer :: isize,ixs,iys,ix_mask,iy_mask,lf
    integer :: ixf1,ixf2,iyf1,iyf2,ixm1,ixm2,iym1,iym2,nxmask,nymask
    logical, dimension(max_ima,max_fit) :: scalepsf
    logical, save :: first = .true.
    logical :: last
    integer, save :: is_old
    integer :: kk,istate1
    character(len=5) :: istr
    character(len=20) :: modfile
    real, dimension(100) :: randnum

!    write(*,*) "model:",num_instr,num_image(1),num_image(2),x0(1),y0(1),sig(1),scts(1:4,1)
 
!   call system_clock(clock0,clock2,clock3)


!   write(*,*) "model, scts(1:6):",scts(1:6,1)

!   write(*,*) "model is,num_instr,num_image(1:3):",is,num_instr,num_image(1:3)


        do i=1,num_instr
         do j=1,num_image(i)  
           ipoint=ip(i,j)
         enddo
        enddo

   if (last) then
!    calculate fraction of source flux on valid mask pixels:
     ix0 = mask%ix_min
     ix1 = mask%ix_max 
     iy0 = mask%iy_min
     iy1 = mask%iy_max
     do n=1,is
       do i=1,num_instr
         do j=1,num_image(i)
           ipoint=ip(i,j)
           totmodel=0.0
           maskmodel=0.0
           yy0=0
           do iy = iy0, iy1
             yy0=yy0+1
             xx0=0
             if (n == 1 .and. ipoint == 1) then
!               write(1,*) ff_save(:,yy0,n,ipoint)
!               write(2,*) (mask%mask(ipoint,:,iy-iy0+1)
             endif
             do ix = ix0, ix1
               xx0=xx0+1
               totmodel=totmodel+ff_save(xx0,yy0,n,ipoint)
               if (mask%mask(ipoint,ix-ix0+1,iy-iy0+1).eq.1)then
                 maskmodel=maskmodel+ff_save(xx0,yy0,n,ipoint)
!                 write(*,*) "on mask:",ix,iy,ff_save(xx0,yy0,n,ipoint)
               else
!                 write(*,*) "off mask:",ix,iy,ff_save(xx0,yy0,n,ipoint)  
               endif 
             enddo
           enddo
           if (totmodel > 0.0) psffrac(n,ipoint)=maskmodel/totmodel
!           write(*,*) maskmodel,totmodel,psffrac(n,ipoint)
         enddo
       enddo
     enddo
!   stop  
     return
   endif




    if (first) then
      allocate(psf_save(nim,is,max_mask,max_mask))
      allocate(ff_save(max_mask,max_mask,is,nim))
      is_old=is
    else if (is .ne. is_old) then
!      deallocate(psf_save)
!      allocate(psf_save(nim,is,max_mask,max_mask))
      deallocate(ff_save)
      allocate(ff_save(max_mask,max_mask,is,nim))
      is_old=is
    endif
 
    small=1.E-10


    if (first) then
!      psf_save(1:max_ima,1:max_fit,1:max_mask,1:max_mask) = 0.0
!      psf_save(1:nim,1:is,1:max_mask,1:max_mask) = 0.0
      scalepsf(1:max_ima,1:max_fit) = .false.
    else
!   check which parameters changed since last call: 
      do n=1,is
        if ((x0(n) .ne. x0_save(n)) .or. (y0(n) .ne. y0_save(n)) .or. (sig(n) .ne. sig_save(n))) then 
          scalepsf(1:max_ima,n) = .false.
          count_model=count_model+1
!          write(*,*) "parameters changed:", is,x0(n),x0_save(n),y0(n),y0_save(n),sig(n),sig_save(n)
        else
          do i=1,num_instr
            do j=1,num_image(i)
              ipoint=ip(i,j)
              if (scts(ipoint,n) .eq. 0.0) then
                scts_scale(ipoint,n) = 0.0
                scalepsf(ipoint,n) = .true.
              else if (scts(ipoint,n) .eq. scts_save(ipoint,n)) then
                scts_scale(ipoint,n) = 1.0
                scalepsf(ipoint,n) = .true.
              else if (abs(scts_save(ipoint,n)) .gt. small) then
                scts_scale(ipoint,n) =  scts(ipoint,n) / scts_save(ipoint,n)
!                write(*,*) ipoint,n,scts_scale(ipoint,n)
                scalepsf(ipoint,n) = .true.
              else
                scts_scale(ipoint,n) = 0.0
                scalepsf(ipoint,n) = .false.
                count_model=count_model+1
              endif
            enddo
          enddo
        endif
      enddo
    endif
!    write(*,*) "scalepsf:", scalepsf(1,1),scalepsf(1,2)

! call system_clock(clock1,clock2,clock3)
!  write(*,*) "clock scaling:", clock1-clock0

!!!! switch off scaling for testing purposes:
!          scalepsf(1:max_ima,1:max_fit) = .false.
!!!!!!
    
!    write(*,*) scalepsf(1:4,1),scts_scale(1:4,1) 
    

    l=1
    lf=1
    yfit1(:)=0.
    yfit2(:)=0.
    yfit3=0.
    fudge=1.0

    do i=1,num_instr


        s3=0.
        do j=1,num_image(i)
!          write(*,*) "nim:",nim
!          write(*,*) "num_instr,num_image(i),i,j,ipoint(i,j):",num_instr,num_image(i),i,j,ip(i,j)
          ipoint=ip(i,j)
          ene=energy(ipoint)
!                    check whether same energy has been calculated for other instrument:
!                    CAL PSFs are identical for all EPIC inst. (as of 28/01/04),
!                    therefore it is pointless to call PSF again for same energy
!VVVVVVVVVVVVVVVVVV  remove, if separate PSF for EPIC instruments should be used
! removed, since fitting was slowed down (GL 03/03/04) 
!
!                    ifound=0
!                    do ii=1,i-1 
!                      do jj=1,num_image(ii)
!                         jpoint=ip(ii,jj)
!                         if (ene .eq. energy(jpoint)) then
!!                           write(*,*)  "found same energy:",ipoint,jpoint
!                           ifound=jpoint
!                           do n=1,is
!                             if  (.not. scalepsf(ipoint,n)) then
!                                
!!                               write(*,*)  "found same energy:",ipoint,jpoint
!                               scalepsf(ipoint,n) = .true.
!                               psf_save(ipoint,n,:,:)=psf_save(jpoint,n,:,:)
!                               scts_scale(ipoint,n) = 1.0
!                             endif
!                           end do
!                           exit
!                         endif
!                      end do
!                      if (ifound > 0) exit
!                   end do
!^^^^^^^^^^^^^^^^^^^
         
          s2=0.
          ix0 = mask%ix_min
          ix1 = mask%ix_max 
          iy0 = mask%iy_min
          iy1 = mask%iy_max
          nxmask=ix1-ix0+1
          nymask=iy1-iy0+1       

          tempsum=0
          yy0=0




!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!  new fft psf call:
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

         if (.true.) then  

          modelima(:,:)=0.0
          do n=1,is

            ixs=nint(x0(n))
            iys=nint(y0(n))
            ix_mask=ixs-ix0
            iy_mask=iys-iy0
            ! source offset from pixel center         
!            xremain=x0(n)-float(ixs)
!            yremain=y0(n)-float(iys)
             xremain=x0(n)-dble(ixs)
             yremain=y0(n)-dble(iys)


            if (scalepsf(ipoint,n) .and. (scts_scale(ipoint,n) .ne. 0.0)) then
!              write(*,*) "scaling"

              if (scts_scale(ipoint,n) .ne. 1.0) then
                ff_save(:,:,n,ipoint)=ff_save(:,:,n,ipoint)*scts_scale(ipoint,n)
              endif
              modelima(:,:)=modelima(:,:)+ff_save(:,:,n,ipoint)


            else
              call fpsf(energy,i,ipoint,xremain,yremain,x0(n),y0(n),sig(n),ecut,isize,n)

              ! copy fima into modelima:

              ixf1=max(1,isize/2-ix_mask+1)
              iyf1=max(1,isize/2-iy_mask+1)
              ixf2=min(isize,isize/2-ix_mask+nxmask)
              iyf2=min(isize,isize/2-iy_mask+nymask)
              ixm1=max(1,ix_mask-isize/2+1)
              iym1=max(1,iy_mask-isize/2+1)
              ixm2=min(nxmask,ix_mask+isize/2)
              iym2=min(nymask,iy_mask+isize/2)

!              write(*,*) ix_mask,iy_mask,nxmask,nymask
!              write(*,*) ixm1,ixm2,iym1,iym2 
!              write(*,*) ixf1,ixf2,iyf1,iyf2 
              
              ff_save(:,:,n,ipoint)=0.0
              ff_save(ixm1:ixm2,iym1:iym2,n,ipoint)=scts(ipoint,n)*fima(ixf1:ixf2,iyf1:iyf2)
              modelima(:,:)=modelima(:,:)+ff_save(:,:,n,ipoint)

!             if (ipoint == 6) then
!               open(unit=1,file='modelim.dat',status='unknown')
!               write(1,*) modelima(:,:)
!               close(1)
!               stop
!             endif

! call system_clock(clock1,clock2,clock3)
!  write(*,*) "clock scaling:", clock1-clock0

            endif
          end do



! call system_clock(clock0,clock2,clock3)
          yy0=0
          do iy = iy0, iy1
            yy0=yy0+1
            xx0=0
            do ix = ix0, ix1
            xx0=xx0+1
              if (mask%mask(ipoint,ix-ix0+1,iy-iy0+1).eq.1) then
                if (expfla) then
                  s1=modelima(xx0,yy0)* &                               !(JR)
                     exp_image(ixb(ix,ipoint),iyb(iy,ipoint),ipoint)    !(JR)
                else
                  s1=modelima(xx0,yy0)
                endif
                ixx=min(max(ix,1),npix(1))
                iyy=min(max(iy,1),npix(2))       
                s1=s1+bg_image(ixb(ixx,ipoint),iyb(iyy,ipoint),ipoint)  !(JR)
                yfit1(lf)=s1
                s2=s2+s1
                lf=lf+1
              endif
            end do
          end do
          yfit2(ipoint)=s2
          s3=s3+s2




! call system_clock(clock1,clock2,clock3)
!  write(*,*) "clock copying:", clock1-clock0
!       endif

!      write(*,*) "yfit2:",yfit2(ipoint) 
         
!      open(unit=1,file='modelim.dat',status='unknown')
!      write(1,*) ff_save(:,:,1,1)
!      close(1)
!      stop


       endif



       !end fft psf
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! call system_clock(clock1,clock2,clock3)
!  write(*,*) "clock scaling:", clock1-clock0


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!  conventional convolution PSF:
!  do not use this part 22/7/04
!      if (.false.) then
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!          do n=1,is
!            if (.not. (scalepsf(ipoint,n) .and. (scts_scale(ipoint,n) .ne. 0.0))) then 
!              count_psf=count_psf+1
!            endif
!          end do
!          do iy = iy0, iy1
!            yy0=yy0+1
!            xx0=0
!            do ix = ix0, ix1
!              xx0=xx0+1
!              if (mask%mask(ipoint,ix-ix0+1,iy-iy0+1).eq.1) then  
!                tempsum=tempsum+1  
!                x1=ix ! +0.5
!                y1=iy ! +0.5
!                s1=0.                  
!                do n=1,is
!                  if (scalepsf(ipoint,n) .and. (scts_scale(ipoint,n) .ne. 0.0)) then
!                    s1=s1+psf_save(ipoint,n,xx0,yy0)*scts_scale(ipoint,n)
!                    psf_save(ipoint,n,xx0,yy0)=psf_save(ipoint,n,xx0,yy0)*scts_scale(ipoint,n)
!                    else
!                   select case (point_resp(i))       
!                     case(1)
!                        stemp=scts(ipoint,n)*psf1(energy,ipoint, &
!                              ix,iy,x0(n)-xoff(expip(i)),y0(n)-yoff(expip(i)), &
!                             xcen(i),ycen(i),sig(n), ecut)
!                        s1=s1+stemp
!                        psf_save(ipoint,n,xx0,yy0)=stemp
!                     case(2)
!                        stemp=scts(ipoint,n)*psf2(energy,ipoint, &
!                              ix,iy,x0(n)-xoff(expip(i)),y0(n)-yoff(expip(i)), &
!                             xcen(i),ycen(i),sig(n), ecut)
!                        s1=s1+stemp
!                        psf_save(ipoint,n,xx0,yy0)=stemp
!                     case(3)
!                        stemp=scts(ipoint,n)*psf3(energy,ipoint, &
!                              ix,iy,x0(n)-xoff(expip(i)),y0(n)-yoff(expip(i)), &
!                             xcen(i),ycen(i),sig(n), ecut)
!                        s1=s1+stemp
!                        psf_save(ipoint,n,xx0,yy0)=stemp
!                     case(4)
!                        stemp=scts(ipoint,n)*psf4(energy,ipoint, &
!                              x1,y1,x0(n)-xoff(expip(i)),y0(n)-yoff(expip(i)), &
!                             xcen(i),ycen(i),sig(n), ecut)
!                        s1=s1+stemp
!                        psf_save(ipoint,n,xx0,yy0)=stemp
!                     case default
!                       call error("WrongPSF","Wrong PSF number") 
!                  end select  
! 
!                  endif
!                end do
!                if (expfla) then
!                  s1=s1*exp_image(ix,iy,ipoint)
!                end if
!                ixx=min(max(ix,1),npix(1))
!                iyy=min(max(iy,1),npix(2))       
!                s1=s1*fudge+bg_image(ixx,iyy,ipoint) 
!                yfit1(l)=s1
!                s2=s2+s1
!                l=l+1
!    
!              end if
!
!            end do
!          end do
!          yfit2(ipoint)=s2   
!          s3=s3+s2
!        endif
!     end of removed part 22/7/04
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!        write(*,*) "ipoint,yfit2(ipoint):",ipoint,yfit2(ipoint)        

        end do
        ! end loop over num_image      
        yfit3=yfit3+s3
!        write(*,*) "lf:",lf
!        write(*,*) "yfit3:",yfit3



!  call system_clock(clock1,clock2,clock3)
!  write(*,*) "clock model:", clock1-clock0


    end do  
!   end loop over num_instr
!   write(*,*) "model scts(1:nim,1) :", scts(1:nim,1)
!   write(*,*) "model scts(1:nim,2) :", scts(1:nim,2)
!   write(*,*) "model yfit2:", yfit2(1:nim)

    ! end loop over num_instr
!    write(*,*) "yfit1:",yfit1(900),yfit1(2036)

    first = .false.
    x0_save=x0
    y0_save=y0
    sig_save=sig
    scts_save=scts


!open(unit=1,file='yfit.dat',status='unknown')   
!write(1,*) yfit1
!close(1)

!stop


!          write(*,*) "scts:",is,ipoint,scts(1,1),scts(1,2),scts(2,1),scts(2,2)
!          write(*,*) "sig:",sig(1),sig(2)
!          write(*,*) "x,y:",x0(1),x0(2),y0(1),y0(2)


  end subroutine model

!  function getEffArea(inst_id,energy,theta,phi)
!
!  real :: getEffArea
!  real(kind=double) :: energy,theta,phi
!  integer :: inst_id
!
!          if (inst_id == 1) then
!             call CAL_setState(instrument=EPN,AccuracyLevel=ACCURACY_MEDIUM)
!           endif
!          if (inst_id == 2) then
!            call CAL_setState(instrument=EMOS1,AccuracyLevel=ACCURACY_MEDIUM)
!          endif
!          if (inst_id == 3) then
!            call CAL_setState(instrument=EMOS2,AccuracyLevel=ACCURACY_MEDIUM)
!          endif  
! 
!          getEffArea=CAL_getEffectiveArea(energy,theta,phi)
!  
!  end function getEffArea

end module emlfit



  










